var ndns = require('../lib/ndns');

var printer = new ndns.DNSParser();
var h = {};
var q = {};
var rr = {};
var qprint, qan, qns, qar;
function printRR (rr) {
    debug(rr.name + "." +
	  "\t" + rr.ttl +
	  "\t" + p_class_syms[rr.class] +
	  "\t" + p_type_syms[rr.type] +
	  "\t" + rr.rdata);
}
printer.onMessageBegin = function () {
    debug("Got answer:");
};
printer.onHeader = function () {
    printer.parseHeader(h);
    debug(";; ->>HEADER<<- opcode: " +
	  res_opcodes[h.opcode] +
	  " status: " + p_rcode_syms[h.rcode][0] +
	  " id: " + h.id);
    qprint = true;
};
printer.onQuestion = function () {
    if (qprint)
	debug(""), debug (";; QUESTION SECTION:"), qprint = false;
    printer.parseQuestion(q);
    debug(";" + q.name + "." +
	  "\t\t" + p_class_syms[q.class] +
	  "\t" + p_type_syms[q.type]);
    qan = true;
};
printer.onAnswer = function () {
    if (qan)
	debug(""), debug (";; ANSWER SECTION:"), qan = false;
    try {
	printer.parseRR(rr);
	printRR(rr);
    } catch (err) {};
    qns = true;
};
printer.onAuthority = function () {
    if (qns)
	debug(""), debug (";; AUTHORITY SECTION:"), qns = false;
    try {
	printer.parseRR(rr);
	printRR(rr);
    } catch (err) {};
    qar = true;
};
printer.onAdditional = function () {
    if (qar)
	debug(""), debug (";; ADDITIONAL SECTION:"), qar = false;
    try {
	printer.parseRR(rr);
	printRR(rr);
    } catch (err) {};
};
printer.onMessageComplete = function () {
    debug("");
    debug(";; Query time: 0 msec");
    debug(";; Server: " + printer.rinfo.address + "#" + printer.rinfo.port +
	  "(" + printer.rinfo.address + ")");
    debug(";; WHEN: ");
    debug(";; MSG SIZE  rcvd: " + printer.msgsize);
};

var resolver = new Client('udp4');
resolver.bind();
resolver.on("message", function (msg, rinfo) {
    printer.reinitialize(msg, 0, msg.length);
    printer.msgsize = msg.length;
    printer.rinfo = rinfo;
    printer.parseMessage();
});

var req = resolver.request(53, '130.244.127.169');

req.addHeader({
    id: 1992,
    rd: 1,
    qdcount: 1});

req.addQuestion({
    name: 'google.com',
    type: 1
});

req.send();
