var ndns = require('../lib/ndns');
var sys = require('sys');
var net = require('net');
var fs = require('fs');

var ns_c = ndns.ns_c;
var ns_t = ndns.ns_t;

var server = ndns.createServer('udp4');

var sendMax = 200;
var queue = [];

server.on("request", function(req, res) {
    res.setHeader(req.header);
    res.header.aa = 1;
    res.header.rd = 0;
    res.header.ancount = 0;

    for (var i = 0; i < req.q.length; i++) {
	var q = req.q[i];
	res.q.add(q);
	var filename = "/" + q.name;
	do {
	    filename = filename.replace(".", "/");
	} while (filename.indexOf(".") > 0);
	fs.readFile(filename, function (err, data) {
	    if (data) {
		res.addRR(q.name, 0, ns_c.in, ns_t.txt, data.slice(0, 200));
		res.header.ancount++;
	    }
	    res.send();
	});
    }
});
server.bind(5353);
