var ndns = require('../lib/ndns');
var resolver = ndns.createClient('udp4');
resolver.bind();

var LOCAL_PORT = 53;
var REMOTE_HOST = "4.4.2.1";
var REMOTE_PORT = 53;

function resolve (domain, rrtype, cb) {
    var req = resolver.request(REMOTE_PORT, REMOTE_HOST);

    rrtype = rrtype.toUpperCase();

    req.setHeader({
	id: 1992,
	rd: 1,
	qdcount: 1});
    req.addQuestion (domain, rrtype, "IN");
    req.send();

    req.on("response", function (res) {
	if (res.header.opcode == ns_r_noerror) {
	    var addrs = [];
	    for (var i = 0; i < res.rr.length; i++) {
		var rr = res.rr[i];
		if (rr.typeName != rrtype)
		    continue;
		if (rr.rdata.length == 1)
		    addrs.push(rr.rdata[0]);
		else
		    addrs.push(rr.rdata);
	    }
	    if (typeof cb === 'function')
		cb (null, addrs);
	}
	else {
	    if (typeof cb === 'function')
		cb (new Error(res.header.opcode));
	}
    });
}

var resolve4 = function (domain, cb) {
    resolve(domain, "A", cb);
};
